require 'nokogiri'
require 'open-uri'
require 'json' 

url = 'http://rubyrogues.com'
doc = Nokogiri::HTML(open(URI url)) 
total = doc.css(".post")[0].css('.entry-title a').text.split(" ")[0].to_i
podcasts = [] 
i = 0

class Struct
  def to_map
    map = Hash.new
    self.members.each { |m| map[m] = self[m] }
    map
  end

  def to_json(*a)
    to_map.to_json(*a)
  end
end

class Podcast < Struct.new(:title,:number,:url,:download_url,:panelists,:published_at); end 

while i < total do 
  i += 1
  n = "%03d" % i
  begin 
    url = "http://rubyrogues.com/#{n}"
    doc = Nokogiri::HTML(open(URI url)) 
    title = doc.css(".post")[0].css(".entry-title").text.split(" ")[1..-1].join(" ")
    published_at = doc.css("abbr.published")[0].text
    number = i 
    download_url = doc.css(".powerpress_link_d")[0].attributes['href'].text rescue nil 
    panelists = doc.css(".entry-content ul")[0].css("li").collect{|li| li.text.split(" (")[0] }.join(", ") || nil
    
    podcast = Podcast.new(title,number,url,download_url, panelists, published_at) 
    podcasts << podcast
    jj JSON.parse(podcast.to_json)
  rescue 
    p "#{n}: failure!"
  end 
end 

podcasts

